<template>
  <el-main>
    <el-form ref="form" :model="form" label-width="80px">
      <el-form-item label="告知事项">
        <el-input type="textarea"
                  :row="4"
                  placeholder="依据财政部财税〔2020〕54号《罚没财物管理办法》 第十四条的规定，告知如下：
                   除法律法规另有规定外，容易损毁、灭失、变质、保管困难或者保管费用过高、季节性商品等不宜长期保存的物品，长期不使用容易导致机械性能下
                   降、价值贬损的车辆、船艇、电子产品等物品，以及有效期即将届满的汇票、本票、支票等，在确定为罚没财物前，经权利人同意或者申请，并经执
                   法机关负责人批准，可以依法先行处置；权利人不明确的，可以依法公告，公告期满后仍没有权利人同意或者申请的，在采取相关措施留存证据后，
                   可以依法先行处置。先行处置所得款项按照涉案现金管理。"
                  v-model="form.unitName">
        </el-input>
      </el-form-item>
      <el-form-item label="措施文号">
        <el-input type="text"
                  placeholder="请输入措施文号"
                  v-model="form.unitName">
        </el-input>
      </el-form-item>
      <el-form-item label="物品范围">
        <el-checkbox-group v-model="form.checkList">
          <el-checkbox label="复选框 A">
            查封 /扣押的全部物品见附件：《查封、扣押物品清单
          </el-checkbox>
          <el-checkbox label="复选框 B">
            查
            封/扣押物品中的下列物品：
            <el-input type="text"
                      placeholder="请输入查封/扣押物品中的下列物品"
                      v-model="form.unitName">
            </el-input>
          </el-checkbox>
        </el-checkbox-group>
      </el-form-item>
      <el-form-item label="物品范围">
        <el-checkbox-group v-model="form.checkList">
          <el-checkbox label="复选框A">
            委托
            <el-input type="text"
                      placeholder="请输入委托物品"
                      v-model="form.unitName">
            </el-input>
            依法进行拍卖；
          </el-checkbox>
          <el-checkbox label="复选框B">
            通过
            <el-input type="text"
                      placeholder="请输入变卖方式"
                      v-model="form.unitName">
            </el-input>
            方式进行变卖；
          </el-checkbox>
          <el-checkbox label="复选框C">
            <el-input type="text"
                      placeholder="请输入其他范围"
                      v-model="form.unitName">
            </el-input>
          </el-checkbox>
        </el-checkbox-group>
      </el-form-item>
      <el-row>
        <el-col :span="12">
          <el-form-item label="联系人">
            <el-input type="text"
                      v-model="form.name"
                      placeholder="请输入联系人姓名">
            </el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="联系电话">
            <el-input type="text"
                      v-model="form.name"
                      placeholder="请输入联系电话">
            </el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="联系地址">
        <el-input type="text"
                  v-model="form.name"
                  placeholder="请输入联系地址">
        </el-input>
      </el-form-item>
      <el-row>
        <el-col :span="12">
          <el-form-item label="权力人">
            <el-input type="text"
                      v-model="form.name"
                      placeholder="请输入权力人姓名">
            </el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="签字日期">
            <el-date-picker
              v-model="form.unitName"
              type="date"
              :value-format="'yyyy-MM-dd'"
              placeholder="选择签字日期">
            </el-date-picker>
          </el-form-item>
        </el-col>
      </el-row>

      <WordView ref="wordInfo" :isShowYulan="showView" @cancel="cancelWord"></WordView>
    </el-form>

    <div style="text-align: center">
      <el-button v-if="isFinish!='2'" plain @click="dataFormSubmit('0')">保存</el-button>
      <el-button v-if="isFinish!='2'" type="warning" plain @click="dataFormSubmit('1')">定稿</el-button>
      <el-button type="primary" plain @click="viewVord(form)">预览</el-button>
      <el-button type="success" plain @click="downloadWord(form)">下载</el-button>
    </div>
  </el-main>
</template>

<script>
import WordView from "@/views/News/word-view";
import {getObj, saveObj} from "@/api/News/DisposalOfItems";
import moment from "moment";

export default {
  name: "DisposalOfItems",
  props: ['isShowYulan','id','isFinish','processId','title'],
  components:{
    WordView
  },
  data() {
    return {
      showView:false,
      form: {
        registerState:'',
        unitName: '',//单位简称
        askdPersion: '',//当事人姓名或单位
        breakLowTime: '',//违规时间
        breakLowContent: '',//违规行为
        lows: '',//违反法律条例
        tiao:'',
        askdTime: '',//通知时间
        askdAdress: '',//承办机构
        takeEvidenceOthers: '',//其他内容
        takeEvidences: [],
        linkMan: '',//联系人
        linkPhone: '',//联系电话
        issuingDate: '',//扣章日期
      },
      formLabelWidth: "140px"
    }
  },
  created() {
    this.init()
  },
  methods: {
    init() {
      getObj(this.id).then((res) => {
        if (res.data.code == 0) {
          // 转换null为""
          // let v = res.data.data;
          // for (let attr in v) {
          //   if (v[attr] == null) {
          //     v[attr] = "";
          //   }
          // }
          // let str = JSON.stringify(v);
          // let data = JSON.parse(str);
          this.form = res.data.data;
        }
      });
    },

    dataFormSubmit(type) {
      console.log(type)
      this.$refs['form'].validate((valid) => {
        if (valid) {
          let obj = this;
          if ("1" == type) {
            this.$confirm('保存为定稿将不能修改，是否继续？', '提示', {
              confirmButtonText: '是',
              cancelButtonText: '否',
              type: 'warning'
            }).then(function () {
              obj.form.registerState = type;
              obj.form.registerId = obj.id;
              obj.form.processId = obj.processId;
              saveObj(obj.form).then((res) => {
                // this.submitLoading = false;
                if (res.data.code == 0) {
                  obj.$message.success('操作成功');
                  obj.cancel();
                  obj.$emit('getDataList');
                }
              })
            })
          } else {
            obj.form.registerState = type;
            obj.form.registerId = obj.id;
            obj.form.processId = obj.processId;
            saveObj(obj.form).then((res) => {
              // this.submitLoading = false;
              if (res.data.code == 0) {
                obj.$message.success("操作成功");
                obj.cancel();
                obj.$emit('getDataList');
              }
            })
          }
        }
      })
    },
    cancel() {
      this.$emit('cancel', false);
    },
    cancelWord() {
      this.showView = false;
    },
    viewVord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      //↓↓↓↓↓↓以下部分根据具体业务修改↓↓↓↓↓↓
      //格式转换
      let wordData = this.transforData(data);
      //↑↑↑↑↑↑以上部分根据具体业务修改↑↑↑↑↑↑
      this.showView = true;
      this.$nextTick(() => {
        this.$refs.wordInfo.init(wordData, "/wordes/dcxwtzs.docx");
      })
    },
    downloadWord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      let wordData = this.transforData(data);
      WordView.methods.exportDoc(wordData, "/wordes/dcxwtzs.docx", title+".docx");
    },
    transforData(obj) {
      let s = JSON.stringify(obj);
      let data = JSON.parse(s);

      let str = data.takeEvidences;
      if (str.indexOf("0") >= 0){
        data.zi = true;
        data.ran = false;
      }else {
        data.zi = false;
        data.ran = true;
      }
      if (str.indexOf("1") >= 0){
        data.ge = true;
        data.ti = false;
      }else {
        data.ge = false;
        data.ti = true;
      }
      if (str.indexOf("2") >= 0){
        data.qi = true;
        data.ta = false;
      }else {
        data.qi = false;
        data.ta = true;
      }
      if (data.breakLowTime != '' && data.breakLowTime != null) {
        data.breakLowTime = moment(data.breakLowTime).format('YYYY年MM月DD日');
      }else {
        data.breakLowTime = '  年  月  日'
      }
      if (data.askdTime != '' && data.askdTime != null) {
        data.askdTime = moment(data.askdTime).format('YYYY年MM月DD日HH时mm分');
      }else {
        data.breakLowTime = '  年  月  日  时  分'
      }
      if (data.issuingDate != '' && data.issuingDate != null) {
        data.issuingDate = moment(data.issuingDate).format('YYYY年MM月DD日');
      }else {
        data.issuingDate = '  年  月  日'
      }

      return data;
    }
  }
}
</script>

<style scoped>

</style>
